#include <stdio.h>
#include <stdlib.h>
#define SIZE 256*256

typedef unsigned char BYTE;

void main()
{
   int i, j,x, y, nEdgeSum, nSobelMask[3][3] = { -1, 0, 1, -2, 0, 2, -1, 0, 1};
   
   FILE* fpIn, *fpOut;
   BYTE* pBufIn = (BYTE*)malloc(SIZE);
   BYTE* pBufOut = (BYTE*)malloc(SIZE);
   
   fpIn = fopen("lena256.raw", "rb");
   fpOut = fopen("lenaedge.raw", "wb");
   fread(pBufIn, 1, SIZE, fpIn);
   
   for (i=1; i<255; i++)
   {
      for (j=1; j<255 ; j++)
      {
         nEdgeSum = 0;
         
         for(y=-1; y<=1; y++)
         {
            for(x=-1; x<=1; x++)
            {
               nEdgeSum += pBufIn[(i+y)*256 + j+x]* nSobelMask[y+1][x+1];
            }
         }
         
         if(nEdgeSum > 128 || nEdgeSum < -128)
            pBufOut[i*256+j] = (BYTE)(nEdgeSum);
         else 
            pBufOut[i*256+j] = 0;
      }
   }
   
   fwrite(pBufOut, 1, SIZE, fpOut);
   fclose(fpIn);
   fclose(fpOut);
   free(pBufIn);
   free(pBufOut);
}

   
